// ==UserScript==
// @id             iitc-plugin-highlight-portals-upgrade@vita10gy
// @name           IITC plugin: highlight portals you can upgrade to a specific level
// @category       Highlighter
// @version        0.1.0.20131122.201127
// @namespace      https://github.com/jonatkins/ingress-intel-total-conversion
// @updateURL      none
// @downloadURL    none
// @description    [fdroid-2013-11-22-201127] Uses the fill color of the portals to highlight portals you can upgrade to a specific level.
// @include        https://www.ingress.com/intel*
// @include        http://www.ingress.com/intel*
// @match          https://www.ingress.com/intel*
// @match          http://www.ingress.com/intel*
// @grant          none
// ==/UserScript==


function wrapper(plugin_info) {
// ensure plugin framework is there, even if iitc is not yet loaded
if(typeof window.plugin !== 'function') window.plugin = function() {};

//PLUGIN AUTHORS: writing a plugin outside of the IITC build environment? if so, delete these lines!!
//(leaving them in place might break the 'About IITC' page or break update checks)
plugin_info.buildName = 'fdroid';
plugin_info.dateTimeVersion = '20131122.201127';
plugin_info.pluginId = 'portal-highlighter-can-make-level';
//END PLUGIN AUTHORS NOTE



// PLUGIN START ////////////////////////////////////////////////////////

// use own namespace for plugin
window.plugin.portalHighligherPortalsCanMakeLevel = function() {};

window.plugin.portalHighligherPortalsCanMakeLevel.highlight = function(data,highlight_level) {
  var d = data.portal.options.details;
  var current_level = Math.floor(getPortalLevel(d));
  var potential_level = Math.floor(window.potentialPortalLevel(d));
  var opacity = .7;
  if( potential_level > current_level && potential_level === highlight_level) {
    color = 'red';
    data.portal.setStyle({fillColor: color, fillOpacity: opacity});
  } 
}

//determines the level of poral a user can make all on their own
window.plugin.portalHighligherPortalsCanMakeLevel.playerCanSoloLevel = function(lvl) {
  var renators_total = 0;
  var renators_placed = 0;
  var resonator_level = PLAYER.level
  while(renators_placed < 8) {
    for(var i = 0; i<MAX_RESO_PER_PLAYER[resonator_level]; i++) {
      if(renators_placed < 8) {
        renators_total += resonator_level;
        renators_placed++;
      }
    }
    resonator_level--;
  }
  return(Math.floor(renators_total/8));
}
window.plugin.portalHighligherPortalsCanMakeLevel.getHighlighter = function(lvl) {
  return(function(data){ 
    window.plugin.portalHighligherPortalsCanMakeLevel.highlight(data,lvl);
  });  
}


var setup =  function() {
  // This is the maximum level of a portal a user can be the "last peice of"
  // yes, even a level 1 can be the difference in bumping a portal up to level 7
  var max_can_complete = 7;
  if(PLAYER.level === 8) {
    max_can_complete = 8;
  }
  // The rational behind the "minimum" level below is that showing a level 7 player, for example, all the portals they can make
  // a level 5 would be silly, as they can make ANY portal a level 5.
  for(var ptl_lvl = window.plugin.portalHighligherPortalsCanMakeLevel.playerCanSoloLevel()+1; ptl_lvl<=max_can_complete; ptl_lvl++) {
    window.addPortalHighlighter('Can Make Level ' + ptl_lvl, window.plugin.portalHighligherPortalsCanMakeLevel.getHighlighter(ptl_lvl));
  }
}

// PLUGIN END //////////////////////////////////////////////////////////


setup.info = plugin_info; //add the script info data to the function as a property
if(!window.bootPlugins) window.bootPlugins = [];
window.bootPlugins.push(setup);
// if IITC has already booted, immediately run the 'setup' function
if(window.iitcLoaded && typeof setup === 'function') setup();
} // wrapper end
// inject code into site context
var script = document.createElement('script');
var info = {};
if (typeof GM_info !== 'undefined' && GM_info && GM_info.script) info.script = { version: GM_info.script.version, name: GM_info.script.name, description: GM_info.script.description };
script.appendChild(document.createTextNode('('+ wrapper +')('+JSON.stringify(info)+');'));
(document.body || document.head || document.documentElement).appendChild(script);


