// ==UserScript==
// @id             iitc-plugin-highlight-outbound-link-counter@cathesaurus
// @name           IITC plugin: highlight portals running low on outbound links
// @category       Highlighter
// @version        0.1.0.20131122.201127
// @namespace      https://github.com/jonatkins/ingress-intel-total-conversion
// @updateURL      none
// @downloadURL    none
// @description    [fdroid-2013-11-22-201127] Uses the fill color of the portals to show the number of outbound links: red = 8 (i.e. no more outbound links may be made), orange = 6 or 7, yellow = 4 or 5.
// @include        https://www.ingress.com/intel*
// @include        http://www.ingress.com/intel*
// @match          https://www.ingress.com/intel*
// @match          http://www.ingress.com/intel*
// @grant          none
// ==/UserScript==


function wrapper(plugin_info) {
// ensure plugin framework is there, even if iitc is not yet loaded
if(typeof window.plugin !== 'function') window.plugin = function() {};

//PLUGIN AUTHORS: writing a plugin outside of the IITC build environment? if so, delete these lines!!
//(leaving them in place might break the 'About IITC' page or break update checks)
plugin_info.buildName = 'fdroid';
plugin_info.dateTimeVersion = '20131122.201127';
plugin_info.pluginId = 'portal-highlighter-outbound-link-counter';
//END PLUGIN AUTHORS NOTE



// PLUGIN START ////////////////////////////////////////////////////////

// use own namespace for plugin
window.plugin.portalHighlighterOutboundLinkCounter = function() {};

window.plugin.portalHighlighterOutboundLinkCounter.highlight = function(data) {
  var d = data.portal.options.details;
  var outgoing = 0;
  var playerFaction = 0;

  if (window.PLAYER.team === 'RESISTANCE') {
    playerFaction = window.TEAM_RES;
  } else {
    playerFaction = window.TEAM_ENL;
  }

  // Only interested in portals of player's faction
  if(getTeam(d) === playerFaction) {
    if(d.portalV2.linkedEdges) $.each(d.portalV2.linkedEdges, function(ind, link) {
      if (link.isOrigin) {
        outgoing++;
      }
    });

    if(outgoing > 3) {
      if(outgoing < 6) {
        color = 'yellow';
      } else if(outgoing < 8) {
        color = 'orange';
      } else {
        color = 'red';
      }
      var params = {fillColor: color, fillOpacity: 1};
      data.portal.setStyle(params);
    }
  }
}

var setup =  function() {
  window.addPortalHighlighter('Outbound Links', window.plugin.portalHighlighterOutboundLinkCounter.highlight);
}

// PLUGIN END //////////////////////////////////////////////////////////


setup.info = plugin_info; //add the script info data to the function as a property
if(!window.bootPlugins) window.bootPlugins = [];
window.bootPlugins.push(setup);
// if IITC has already booted, immediately run the 'setup' function
if(window.iitcLoaded && typeof setup === 'function') setup();
} // wrapper end
// inject code into site context
var script = document.createElement('script');
var info = {};
if (typeof GM_info !== 'undefined' && GM_info && GM_info.script) info.script = { version: GM_info.script.version, name: GM_info.script.name, description: GM_info.script.description };
script.appendChild(document.createTextNode('('+ wrapper +')('+JSON.stringify(info)+');'));
(document.body || document.head || document.documentElement).appendChild(script);


